Subject: RE: bug#41250: 28.0.50; Dired displays unconditionally ls-switches on modeline

From: Drew Adams <[email-masked]>
Date: Sat, 16 May 2020 07:42:12 -0700 (PDT)

> > maybe Drews idea to have a format string is
> > maybe the most flexible one?

A function, rather than just a format string, is
clearly the most flexible one, of the ones I made
available as choices for the option value.

And many more users will know how to define a
simple function that returns something than will
necessarily know about `format' etc.

> Not IMO.  Using format strings and functions is
> "advanced usage", which is normally barred for
> newbies and relatively inexperienced Emacs users.
> Popular options should IMO be exposed though
> easier customization values.

Where is it barred to have an option `choice'
that allows for a function value?

If that were the case then we would presumably
not even have `function' as a `defcustom' type.
Likewise other types, such as `regexp' and `alist'.

The Customize UI is, after all, for newbies too.
Some (not I) think it is primarily or _only_ for
newbies.

But more importantly, there are also very simple
choices defined for this option (and `function'
is the last in `Value Menu').  And the default
behavior is nil - which keeps the longstanding
behavior.

Nothing obliges a newbie to customize the option
to a function value.  Barring the use of options
that have a function - or a regexp, for that
matter - as one of a set of `choice's would be
very wrong, IMHO.  And I don't see such a barring
or convention anywhere in the doc.

Anyway, do what you want.  If this isn't taken
up by vanilla Emacs I'll use it in Dired+.  My
preference is for vanilla Emacs to do it, to
lessen my own maintenance burden, but it's not
a big deal.